var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};

// src/index.ts
import { toString } from "hast-util-to-string";
import treeSitter from "tree-sitter-highlight";
import { visit } from "unist-util-visit";
var defineOptions = (options) => options;
var defaultOptions = defineOptions({
  ignoreUnknownLanguage: true
});
var langMap = {
  "js": 0,
  "javascript": 0,
  "jsx": 1,
  "ts": 2,
  "typescript": 2,
  "tsx": 3,
  "css": 4
};
var attacher = (options = {}) => {
  const resolvedOptions = __spreadValues(__spreadValues({}, defaultOptions), options);
  const transformer = (tree) => {
    visit(tree, "element", (node, index, parent) => {
      if (!parent || parent.tagName !== "pre" || node.tagName !== "code") {
        return;
      }
      const lang = getLanguage(node);
      if (lang === null) {
        if (resolvedOptions.ignoreUnknownLanguage)
          return node;
        else
          throw new Error(`[rehype-tree-sitter-highlight]: unknown language`);
      }
      const code = treeSitter.highlightHast(toString(node), lang);
      parent.properties = code.properties;
      parent.children = code.children;
    });
  };
  return transformer;
};
var getLanguage = (node) => {
  const className = node.properties.className || [];
  for (const classListItem of className) {
    if (classListItem.slice(0, 9) === "language-") {
      const classNameLanguage = classListItem.slice(9).toLowerCase();
      const matchedLanguage = langMap[classNameLanguage];
      if (matchedLanguage !== void 0)
        return matchedLanguage;
    }
  }
  return null;
};
var src_default = attacher;
export {
  src_default as default
};
